package grizzlytestbed;

import com.sun.grizzly.comet.CometContext;
import com.sun.grizzly.comet.CometEngine;
import com.sun.grizzly.comet.CometEvent;
import com.sun.grizzly.comet.CometHandler;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Timer;
import java.util.TimerTask;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.json.JSONException;
import org.json.JSONObject;



/**
 *
 * @author richard
 */
public class IeCometTest extends HttpServlet{
// servlet stuff
    public void destroy() {}
    public ServletConfig getServletConfig() {return getServletConfig();}
    public String getServletInfo() { return getServletInfo();}
    public void init(ServletConfig arg0) throws ServletException {}

    static CometContext cc;
    static CometHandler ch;

    public void service(ServletRequest request, ServletResponse response) throws ServletException, IOException {
        try{

            System.out.println("Let's get this party started....");
            PrintWriter writer = response.getWriter();
            writer.write("<html><head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /></head><body onload=\"parent.callback('reconnect', false)\">");
            writer.flush();
            cc = CometEngine.getEngine().register("Hailie's comet context");
            ch = new CometHandlerImpl();
            ch.attach(response);
            cc.addCometHandler(ch);
            cc.setExpirationDelay(-1);
            datapush.instance.pushdata();

        }catch(Exception i){i.printStackTrace();}
    }

     enum datapush{
      instance;
      Timer t = new Timer();
      Integer i = 0;
        public void pushdata() {

        t.scheduleAtFixedRate(new TimerTask() {

                @Override
                public void run() {
                  try{
                  JSONObject jso = new JSONObject();
                  jso.put("varname", "Trivial Counter");
                  jso.put("varvalue", i++);
                   System.out.println("comet handlers="+ cc.getCometHandlers().size());
                  if(i < 11 && cc.getCometHandlers().size() > 0)
                    cc.notify(jso);
                  else {
                      i=0;
                      
                  }
                  }catch(IOException ioe){ioe.printStackTrace();}
                  catch(JSONException jse){jse.getLocalizedMessage();}
                }
            }, 6000, 6000);
        }


    }

    static class CometHandlerImpl implements CometHandler<HttpServletResponse>{
    HttpServletResponse response;
    public final static String SCRIPT_TEMP = "<script type=\"text/javascript\">if(parent.callback)parent.callback(\"%s\",%s);</script>";

        public void attach(HttpServletResponse arg0) {
           this.response = arg0;
        }

        public void onEvent(CometEvent arg0) throws IOException {
         JSONObject jo = (JSONObject)arg0.attachment();
         System.out.println(jo.toString());
          response.getWriter().write(String.format(SCRIPT_TEMP, "onFire",jo.toString()));
          this.response.getWriter().flush();

          // this.onTerminate(arg0);  <-- No longer needed , YEAA!!!
        }

        public void onInitialize(CometEvent arg0) throws IOException {
            System.out.println("Initialized Handler");
        }

        public void onInterrupt(CometEvent arg0) throws IOException {
            System.out.println("onInterrupt");
            arg0.getCometContext().removeCometHandler(this);
        }

        public void onTerminate(CometEvent arg0) throws IOException {
            System.out.println("onTerminate");
            arg0.getCometContext().removeCometHandler(this);
        }

    }


}
